"use strict";


//------------------------------
//タイマー
//------------------------------
//【Timer1】爆破
var timer1 = null;
const timer1Interval = 200;
var timer1Cnt = 0;

//【Timer2】相手検索中
var timer2 = null;
const timer2Interval = 200;
var timer2Cnt = 0;
var timer2CntMax = 15;
var timer2IsEndOk = true;

//【Timer3】文字エフェクト
var timer3 = null;
const timer3Interval = 200;
var timer3Cnt1 = 2;
var timer3Cnt2 = 2;
var timer3Cnt3 = 2;
var timer3Cnt4 = 2;
var timer3IsDec1 = false;
var timer3IsDec2 = false;
var timer3IsDec3 = false;
var timer3IsDec4 = false;
var timer3ImageCnt = 0;

//【Timer4】カウントダウン
var timer4 = null;
const timer4Interval = 1500;
const timer4MAX1 = 20;
const timer4MAX2 = 5;
var timer4Cnt1 = timer4MAX1;
var timer4Cnt2 = timer4MAX2;
var timer4AutoOpe1 = false;	//自動マス配置中フラグ:OFF
var timer4AutoOpe2 = false;	//自動TurnEnd中フラグ:OFF

//【Timer5】カウントダウンTimeOut【自動操作】
var timer5 = null;
const timer5Interval = 200;
var timer5Cnt = 0;

//【Timer6】AI【自動操作】
var timer6 = null;
const timer6Interval = 250;
var timer6CntMax = 4;
var timer6Cnt = 0;
var timer6AutoOpe1 = false;	//自動マス配置中フラグ:OFF
var timer6AutoOpe2 = false;	//自動爆弾配置中フラグ:OFF
var timer6AutoOpe3 = false;	//自動TurnEnd中フラグ:OFF
var ranPutMax = 6;//6,3
var ranPutMin = 2;//2,1

//------------------------------
//共通
//------------------------------
let MAX_PUTS = 5;
let gameCnt = 1; //1～5
let isGameEnd = true;
let bombMode = false;

let survivalCnt = 0;
let survivalMaxCnt = 0;

let userNames = new Array();

let persons = new Array();
let nowPerson = new PersonObj();

let highlightMe = "outline7down";
let highlightOther = "outline7down";

const BAD_TEXT = ["クックック<br>さよならですね",
				"クックック<br>無様な姿ですね",
				"クックック<br>また来て下さいね",
				"クックック<br>つまらない存在ですね",
				"クックック<br>神にも悪魔にも見放されたのですね"];
let badArr = new Array();

const GOOD_TEXT = ["クックック<br>これで運を使い果たしましたね",
				 "クックック<br>死は何ものにも代え難いご褒美ですね",
				 "クックック<br>絶望と悲鳴は最高のご馳走ですね",
				 "クックック<br>生きるとは奪うことなのですね",
				 "クックック<br>なぜそこまでして生きたいのですか？"];
let goodArr = new Array();

const NAME_TEXT = [
"漆黒の龍","龍さん","Makoty","すすき","ゆうたパパ","げんじろう","モカ","たま","小麦","雲母",
"プリン","マカロン","おつまみ","するめ","ひまわり","つつじ","Lily","デイジー","Kirby","キリト",
"リネア","Rudi","Mental","ファマエル","ミカエル","ガブリエル","聖母","熾天使","大天使","バルク",
"セト","アヌビス","うんこちゃん","ホルス","ラー","バフォメット","マモン","ゼパル","オーガ","グレムリン",
"ライム","ルーク","アイス","アル","エンカ","とリバード","ときど","ぱいなぽ～","はしご","ポッキー",
"†暗黒天使†","卍漆黒の翼卍","†伊藤博文†","†KURAUDO","†黒滅龍†","†聖天使猫姫†","特攻☆天使","卍霊夢は俺の嫁卍","xX滅龍神Xx","SEHYIROS",
"戸愚呂ママ","勃起天使","真夜中のココア","kuroneko","xx殺戮者xx","x闇の執行人x","†孤高の戦士†","梅沢富美男","パパのムスコ","ゆうた",
"すらいむ","スライム","Ｇ・スライム","流離いの修羅威武","鯖ミックス","緊急指令。","GARF","オレサマノフ","迅帝","フォルレイン",
"レイン","ふぉる","ネギ","やくみ","やくみネギ","支配者ルシファー","伝説の不死人","北浦和エノケン","もょもと","流離",
"レイガンド","エンタの貧乏神","吉野超龍","辛酸カリリ","想人の記憶","†妖魔†","血に染まりし者","蒼雷のアーク","†漆黒の堕天使†","唯緒",
"埋れ木","meister","ほむら","漆黒の魔術師","夢見朔夜","風雅","†ルシフェル†","†ルシファー†","†ロキ†","†クロノス†",
"夢幻","哀唄","紫苑","闇夜","鮮血切首","夢幻霧花","奈々氏","卍鴉神卍","☆まさふみ☆","JOKER",
"孤高の渡り鳥","ゆうた亜種","シャブ原キメ太郎","elua","ekolu","mahalo","Raven","ポタモガーレ","ウェイブ","Amiba",
"Orseolo","おにぎりの具","樹液ぺろぺろくん","おやすミンスク","Valkyrie","Aurora","Ariadne","wood","Rouge","ロブ・ロイ",
"レット","バトラー","ちょこれーと","びたみん","こたつ","もふもふ","きょん","ぴょこんぴょこん","馬鹿のハンス","ラプンツェル"];




//***************************************************************************************
//***************************************************************************************


//------------------------------
//ゲームする人オブジェクト
//------------------------------
function PersonObj() {
    this.me = false;	//true:自分、false:相手
    this.turnNo = 0;	//1:先手、2:後手
    this.allPuts = [false,false,false,false,false,
					false,false,false,false,false,
					false,false,false,false,false,
					false,false,false,false,false,
					false,false,false,false,false];
    this.nowPuts = [-1,-1,-1,-1,-1];
    this.bombPut = -1;
}


//***************************************************************************************
//***************************************************************************************


//--------------------------------------------------
//【FromHTML】自動開始処理
//--------------------------------------------------
function autoStart() {

/*
	//効果音ミュートON【スマホTimer対策】
	isSoundFirst = true;
*/

	//Html初期化処理
	initHtml();

	//【Timer3】文字エフェクト
	switchTimer(3,"ON");

	//BGMプレイリスト
	for (let i=0; i < BGM_TEXT.length; i++) {
		bgmPlayList.push(BGM_TEXT[i]);
	}
	//勝ちMsg
	for (let i=0; i < GOOD_TEXT.length; i++) {
		goodArr.push(GOOD_TEXT[i]);
	}
	//負けMsg
	for (let i=0; i < BAD_TEXT.length; i++) {
		badArr.push(BAD_TEXT[i]);
	}
}
//--------------------------------------------------
//Html初期化処理
//--------------------------------------------------
function initHtml() {

	//変数初期化
	gameCnt = 1; //1～5
	bombMode = false;

	userNames = new Array();

	persons = new Array();

	//先手
	persons[0] = new PersonObj();
	persons[0].turnNo = 1;
	//後手
	persons[1] = new PersonObj();
	persons[1].turnNo = 2;

	//先手後手ランダム決定
	persons[getRandomNum(2,0)].me = true;

	//現在ターンに先手を入れる
	nowPerson = new PersonObj();
	nowPerson = persons[0];

	//tdの背景初期化
	for (let i=0; i < tableElements.length; i++) {
		tableElements[i].className = "bk_empty";
		getObj("td"+i).className = "";
	}

	//先手マスランダム配置
	let index = getRandomNum(25,0);
	if(getMeTurnNo() == 1){
		tableElements[index].className = "bk_fixManMe";
		getObj("td"+index).className = "imgBomb1";
	}else{
		tableElements[index].className = "bk_fixManOther";
	}
	persons[0].allPuts[index] = true;
	persons[0].bombPut = index;

	//後手マスランダム配置
	while(persons[1].bombPut == -1) {
		index = getRandomNum(25,0);
		if(persons[0].allPuts[index] == false){
			if(getMeTurnNo() == 2){
				tableElements[index].className = "bk_bgManMe";
				getObj("td"+index).className = "imgBomb1";
			}else{
				tableElements[index].className = "bk_bgManOther";
			}
			persons[1].allPuts[index] = true;
			persons[1].bombPut = index;
		}
	}

	//マス数HTML出力
	outHtmlBoxCnt();

	//------------------------------
	//ローカルストレージから取得
	//------------------------------
	//ローカルストレージからゲーム状態を取得
	let state = getStorage("gameState","");
	if(state != "end"){
		//ローカルストレージに保存
		setStorage("survivalCnt", 0);
	}

	//ローカルストレージからサバイバル日数を取得
	survivalCnt = parseInt(getStorage("survivalCnt",0), 10);
	//ローカルストレージからサバイバル最大日数を取得
	survivalMaxCnt = parseInt(getStorage("survivalMaxCnt",0), 10);
	getObj("txtSurvivalCnt").innerHTML = "サバイバル <span class='font140 white'>" + survivalCnt + "</span> 日経過<br>( 過去最高 <span class='font140 white'>" + survivalMaxCnt + "</span> 日 )";

	//ローカルストレージからユーザ名を取得
	let name = getStorage("UserName","人間No." + getRandomNum(9,0) + getRandomNum(9,0) + getRandomNum(9,0));
	getObj("txtName").value = name;
	if(survivalMaxCnt < 10){
		getObj("txtName").disabled  = true;
		getObj("txtNameMsg1").innerHTML  = "おやおやまた虫けらが来たようだ";
		getObj("txtNameMsg2").innerHTML  = "そなたに名を名乗る資格はない";
		highlightMe = "outline7down";
	}else if(survivalMaxCnt >= 20){
		getObj("txtName").disabled  = false;
		getObj("txtNameMsg1").innerHTML  = "我々はそなたのような存在が大好きだ";
		getObj("txtNameMsg2").innerHTML  = "どうだ仲間にならないか！？";
		highlightMe = "outline7up";
	}else{
		getObj("txtName").disabled  = false;
		getObj("txtNameMsg1").innerHTML  = "我々は実力や才能よりも";
		getObj("txtNameMsg2").innerHTML  = "圧倒的な幸運の持ち主を選ぶ";
		highlightMe = "outline7up";
	}


	//カウントダウン初期値
	getObj("info_timer2").innerHTML = zeroPadding(timer4MAX1,2);

	//音量設定
	isSound = getStorage("isSound","ON");
	isBGM   = getStorage("isBGM"  ,"ON");
	getObj("sound1Btn").value = isSound;
	getObj("sound2Btn").value = isBGM;

	//------------------------------
	//タイマー操作:OFF
	//------------------------------
	//【Timer1】爆破
	switchTimer(1,"OFF");

	//【Timer2】相手検索中
	switchTimer(2,"OFF");

	//【Timer4】カウントダウン
	switchTimer(4,"OFF");

	//【Timer5】カウントダウンTimeOut【自動操作】
	switchTimer(5,"OFF");

	//【Timer6】AI【自動操作】
	switchTimer(6,"OFF");
}
//--------------------------------------------------
//【Timer】タイマー操作
//--------------------------------------------------
function switchTimer(no,type) {

	//【Timer1】爆破
	if(no == 1){
		if(type == "ON"){
			if(timer1 == null){
				initTimerFlag(no);
				timer1 = setInterval(runTimer1,timer1Interval);
			}
		}else{
			if(timer1 != null){
				clearInterval(timer1);
				timer1 = null;
			}
		}
	}
	//【Timer2】相手検索中
	else if(no == 2){
		if(type == "ON"){
			if(timer2 == null){
				initTimerFlag(no);
				timer2 = setInterval(runTimer2,timer2Interval);
			}
		}else{
			if(timer2 != null){
				clearInterval(timer2);
				timer2 = null;
			}
		}
	}
	//【Timer3】文字エフェクト
	else if(no == 3){
		if(type == "ON"){
			if(timer3 == null){
				initTimerFlag(no);
				timer3 = setInterval(runTimer3,timer3Interval);
			}
		}else{
			if(timer3 != null){
				clearInterval(timer3);
				timer3 = null;
			}
		}
	}
	//【Timer4】カウントダウン
	else if(no == 4){
		if(type == "ON"){
			if(timer4 == null){
				initTimerFlag(no);
				timer4 = setInterval(runTimer4,timer4Interval);
			}
		}else{
			if(timer4 != null){
				clearInterval(timer4);
				timer4 = null;
			}
		}
	}
	//【Timer5】カウントダウンTimeOut【自動操作】
	else if(no == 5){
		if(type == "ON"){
			if(timer5 == null){
				initTimerFlag(no);
				timer5 = setInterval(runTimer5,timer5Interval);
			}
		}else{
			if(timer5 != null){
				clearInterval(timer5);
				timer5 = null;
			}
		}
	}
	//【Timer6】AI【自動操作】
	else if(no == 6){
		if(type == "ON"){
			if(timer6 == null){
				initTimerFlag(no);
				timer6 = setInterval(runTimer6,timer6Interval);
			}
		}else{
			if(timer6 != null){
				clearInterval(timer6);
				timer6 = null;
			}
		}
	}
}
//--------------------------------------------------
//【Timer】タイマーフラグ初期化
//--------------------------------------------------
function initTimerFlag(no) {

	//【Timer1】爆破
	if(no == 1){
		timer1Cnt = 0;
	}
	//【Timer2】相手検索中
	else if(no == 2){
		timer2Cnt = 0;
		timer2CntMax = getRandomNum(70,20);
		timer2IsEndOk = true;
	}
	//【Timer3】文字エフェクト
	else if(no == 3){
		timer3Cnt1 = 2;
		timer3Cnt2 = 2;
		timer3Cnt3 = 2;
		timer3Cnt4 = 2;
		timer3IsDec1 = false;
		timer3IsDec2 = false;
		timer3IsDec3 = false;
		timer3IsDec4 = false;
		timer3ImageCnt = 0;
	}
	//【Timer4】カウントダウン
	else if(no == 4){
		timer4Cnt1 = timer4MAX1;
		timer4Cnt2 = timer4MAX2;
		timer4AutoOpe1 = false;	//自動マス配置中フラグ:OFF
		timer4AutoOpe2 = false;	//自動TurnEnd中フラグ:OFF
	}
	//【Timer5】カウントダウンTimeOut【自動操作】
	else if(no == 5){
		timer5Cnt = 0;
	}
	//【Timer6】AI【自動操作】
	else if(no == 6){
		timer6CntMax = getRandomNum(6,3);
		timer6Cnt = 0;
		timer6AutoOpe1 = false;	//自動マス配置中フラグ:OFF
		timer6AutoOpe2 = false;	//自動爆弾配置中フラグ:OFF
		timer6AutoOpe3 = false;	//自動TurnEnd中フラグ:OFF
//		ranPutMax = 6;//6,3
//		ranPutMin = 2;//2,1
	}
}
//--------------------------------------------------
//【Timer3】文字エフェクト
//--------------------------------------------------
function runTimer3() {

	//透過画像の目を動かす
	if(timer3ImageCnt == 10){
		//START画面
		if(getObj("disp_start").className != "invisible"){
			if(getRandomNum(3,0) == 0){
				getObj("disp_start").className = "topImg" + getRandomNum(2,2);
			}else{
				getObj("disp_start").className = "topImg1";
			}
		}
		//SERCH画面
		if(getObj("disp_serch").className != "invisible"){
			if(getRandomNum(2,0) == 0){
				getObj("disp_serch").className = "topImg4";
			}else{
				getObj("disp_serch").className = "topImg1";
			}
		}

		timer3ImageCnt = 0;

	}else{
		timer3ImageCnt++;
	}


	if(timer3Cnt1 == 2){
		if(getRandomNum(100,0) == 0){
			timer3IsDec1 = false;
			timer3Cnt1 = 3;
		}
	}else{
		getObj("mozi1").className = "outline" + timer3Cnt1;
		if(timer3IsDec1){
			timer3Cnt1--;
		}else{
			timer3Cnt1++;
		}

		if(timer3Cnt1 > 7){
			timer3IsDec1 = true;
			timer3Cnt1 = 7;
		}
	}

	if(timer3Cnt2 == 2){
		if(getRandomNum(400,0) == 0){
			timer3IsDec2 = false;
			timer3Cnt2 = 3;
		}
	}else{
		getObj("mozi2").className = "outline" + timer3Cnt2;
		if(timer3IsDec2){
			timer3Cnt2--;
		}else{
			timer3Cnt2++;
		}

		if(timer3Cnt2 > 7){
			timer3IsDec2 = true;
			timer3Cnt2 = 7;
		}
	}

	if(timer3Cnt3 == 2){
		if(getRandomNum(200,0) == 0){
			timer3IsDec3 = false;
			timer3Cnt3 = 3;
		}
	}else{
		getObj("mozi3").className = "outline" + timer3Cnt3;
		if(timer3IsDec3){
			timer3Cnt3--;
		}else{
			timer3Cnt3++;
		}

		if(timer3Cnt3 > 7){
			timer3IsDec3 = true;
			timer3Cnt3 = 7;
		}
	}

	if(timer3Cnt4 == 2){
		if(getRandomNum(300,0) == 0){
			timer3IsDec4 = false;
			timer3Cnt4 = 3;
		}
	}else{
		getObj("mozi4").className = "outline" + timer3Cnt4;
		if(timer3IsDec4){
			timer3Cnt4--;
		}else{
			timer3Cnt4++;
		}

		if(timer3Cnt4 > 7){
			timer3IsDec4 = true;
			timer3Cnt4 = 7;
		}
	}
}
//--------------------------------------------------
//マス数HTML出力
//--------------------------------------------------
function outHtmlBoxCnt() {

	//マス数を取得
	let arr = arrBoxCnt();

	getObj("info_boxMe").innerHTML    = "獲得マス[ " + arr[0] + " ]";
	getObj("info_boxOther").innerHTML = "獲得マス[ " + arr[1] + " ]";
}
//--------------------------------------------------
//マス数を取得
//--------------------------------------------------
function arrBoxCnt() {

	let cnt1 = 0;
	let cnt2 = 0;

	//固定マス数をカウント
	for (let i=0; i < nowPerson.allPuts.length; i++) {
		if(persons[0].allPuts[i]){
			cnt1++;
		}
		if(persons[1].allPuts[i]){
			cnt2++;
		}
	}
	//新規マス数をカウント
	for (let i=0; i < nowPerson.nowPuts.length; i++) {
		if(persons[0].nowPuts[i] != -1){
			cnt1++;
			if(persons[1].allPuts[persons[0].nowPuts[i]]){
				cnt2--;
			}
		}
		if(persons[1].nowPuts[i] != -1){
			cnt2++;
			if(persons[0].allPuts[persons[1].nowPuts[i]]){
				cnt1--;
			}
		}
	}

	let arr = new Array();
	if(getMeTurnNo() == 1){
		arr.push(cnt1);
		arr.push(cnt2);
	}else{
		arr.push(cnt2);
		arr.push(cnt1);
	}
	return arr;
}


//***************************************************************************************
//***************************************************************************************


//--------------------------------------------------
//【FromHTML】tableセル押下処理
//--------------------------------------------------
function clickTd(index) {

	//ゲーム終了している場合
	if(isGameEnd){
		return;
	}
	//現在ターンが自分じゃない場合
	if(isNowMe() == false){
		return;
	}
	//【Timer5】カウントダウンTimeOut【自動操作】が動いている
	if(timer5 != null){
		return;
	}

	//マーキング
	putMarking(index);
}
//--------------------------------------------------
//マーキング
//--------------------------------------------------
function putMarking(index) {

	//爆破中
	if(timer1 != null){
		return;
	}

	//爆弾配置モード:ONの場合
	if(bombMode){
		if(tableElements[index].className == "bk_bomb"){
			//爆弾配置
			nowPerson.bombPut = index;

			//爆弾配置HTML出力(自分の爆弾のみ)
			if(isNowMe()){
				for (let i=0; i < tableElements.length; i++) {
					if(i == index){
						getObj("td"+i).className = "imgBomb1";
					}else{
						getObj("td"+i).className = "";
					}
				}
			}

			//ボタン制御
			btnIsDisabled("bombBtn",true);	//無効
			btnIsDisabled("endBtn",false);	//有効
		}
		return;
	}

	//既に配置済みかチェック
	if(nowPerson.allPuts[index]){
		return;
	}

	//マーキングキャンセルの場合
	if(isPutCnt(index)){
		//1マス削除
		if(delPutCnt(index)){
			//マス初期化
			if(persons[(getNowWaitTurn()-1)].allPuts[index]){
				tableElements[index].className = "bk_bgMan" + getWaitMeOtherStr();
			}else{
				tableElements[index].className = "bk_empty";
			}

			//相手が爆弾マスをキャンセルした場合
			if(isNowMe() == false && persons[(getMeTurnNo()-1)].bombPut == index){
				getObj("td"+index).className = "imgBomb1";
			}

			//マス配置HTML出力
			outHtmlPutBox();

			//マス数HTML出力
			outHtmlBoxCnt();
		}
		return;
	}

	//配置できるかチェック
	if(isOnePut(index) == false){
		return;
	}

	if(getPutCnt() < 5){
		//効果音
		soundOld = soundNow;
		soundNow = getRandomNum(7,1);
		while(soundNow == soundOld) {
			soundNow = getRandomNum(7,1);
		}
		soundFunc("click" + soundNow);

		tableElements[index].className = "bk_man" + getNowMeOtherStr();
		addPutCnt(index);

		//マス配置HTML出力
		outHtmlPutBox();

		//マス数HTML出力
		outHtmlBoxCnt();

		//相手が爆弾マスを選んだ場合
		if(isNowMe() == false && persons[(getMeTurnNo()-1)].bombPut == index){
			getObj("td"+index).className = "imgBomb2";
		}
	}
}
//--------------------------------------------------
//ボタン無効
//--------------------------------------------------
function btnIsDisabled(str,flag) {

	getObj(str).disabled = flag;
	if(flag){
		getObj(str).className = "btn0 btnDisabled";
	}else{
		getObj(str).className = "btn0 outline3";
	}
}
//--------------------------------------------------
//現在ターンが自分かどうかを取得
//--------------------------------------------------
function isNowMe() {
	return nowPerson.me;
}
//--------------------------------------------------
//現在ターンの文字列を取得
//--------------------------------------------------
function getNowMeOtherStr() {
	let str;
	if(isNowMe()){
		str = "Me";
	}else{
		str = "Other";
	}
	return str;
}
//--------------------------------------------------
//待機中ターンの文字列を取得
//--------------------------------------------------
function getWaitMeOtherStr() {
	let str;
	if(isNowMe()){
		str = "Other";
	}else{
		str = "Me";
	}
	return str;
}
//--------------------------------------------------
//自分が先手後手のどっちかを取得
//--------------------------------------------------
function getMeTurnNo() {
	let no;
	if(persons[0].me){
		no = persons[0].turnNo;	//1
	}
	if(persons[1].me){
		no = persons[1].turnNo;	//2
	}
	return no;
}
//--------------------------------------------------
//相手が先手後手のどっちかを取得
//--------------------------------------------------
function getOtherTurnNo() {
	let no;
	if(persons[0].me){
		no = persons[1].turnNo;	//2
	}
	if(persons[1].me){
		no = persons[0].turnNo;	//1
	}
	return no;
}
//--------------------------------------------------
//現在のターン番号を取得
//--------------------------------------------------
function getNowTurn() {
	return nowPerson.turnNo;
}
//--------------------------------------------------
//現在待機中のターン番号を取得
//--------------------------------------------------
function getNowWaitTurn() {
	let r = 1;
	if(nowPerson.turnNo == 1){
		r = 2;
	}
	return r;
}
//--------------------------------------------------
//既に現在の配置数にあるかチェック
//--------------------------------------------------
function isPutCnt(index) {

	let r = false;
	for (let i=0; i < nowPerson.nowPuts.length; i++) {
		if(nowPerson.nowPuts[i] == index){
			r = true;
			break;
		}
	}
	return r;
}
//--------------------------------------------------
//配置できるかチェック
//--------------------------------------------------
function isOnePut(index) {
	//上下左右に自マーキングがある場合のみ次マーキング可能
	let isOk = false;

	let top    = parseInt(index - 5, 10);
	let left   = parseInt(index - 1, 10);
	let right  = parseInt(index + 1, 10);
	let bottom = parseInt(index + 5, 10);

	if(index == 5 || index == 10 || index == 15 || index == 20){
		left = -1;
	}
	if(index == 4 || index == 9 || index == 14 || index == 19){
		right = -1;
	}

	if(checkOnePut(top)){
		isOk = true;
	}else if(checkOnePut(left)){
		isOk = true;
	}else if(checkOnePut(right)){
		isOk = true;
	}else if(checkOnePut(bottom)){
		isOk = true;
	}

	return isOk;
}
//--------------------------------------------------
//１マスチェック
//--------------------------------------------------
function checkOnePut(index) {
	let isOk = false;
	if(index >= 0 && index <= 24){
		isOk = nowPerson.allPuts[index];
		if(isOk == false){
			for (let i=0; i < nowPerson.nowPuts.length; i++) {
				if(nowPerson.nowPuts[i] == index){
					isOk = true;
					break;
				}
			}
		}
	}
	return isOk;
}
//--------------------------------------------------
//現在の配置数から削除
//--------------------------------------------------
function delPutCnt(index) {

	let isDelOk = false;
	let no = -1;

	//現在の配置数から削除
	for (let i=0; i < nowPerson.nowPuts.length; i++) {
		if(nowPerson.nowPuts[i] == index){
			nowPerson.nowPuts[i] = -1;
			isDelOk = true;
			no = i;
			break;
		}
	}

	//孤立したマスがないかチェック
	if(isDelOk){
		for (let i=0; i < nowPerson.nowPuts.length; i++) {
			if(nowPerson.nowPuts[i] != -1){
				//経路チェック
				if(checkRoute(nowPerson.nowPuts[i]) == false){
					isDelOk = false;
					break;
				}
			}
		}
	}

	if(isDelOk == false){
		//削除を止め元に戻す
		nowPerson.nowPuts[no] = index;
	}

	return isDelOk;
}
//--------------------------------------------------
//経路チェック
//--------------------------------------------------
function checkRoute(index) {

	//飛び地に1マスだけは元に戻す
	if(isOnePut(index) == false){
		return false;
	}

	//隣接マスが固定マス
	if(checkFix(index)){
//console.log("1hit [" + index + "]→固定");
		return true;
	}

	//-------------
	//新規1マス目
	//-------------
	let arr = new Array();
	let top    = parseInt(index - 5, 10);
	let left   = parseInt(index - 1, 10);
	let right  = parseInt(index + 1, 10);
	let bottom = parseInt(index + 5, 10);

	if(index == 5 || index == 10 || index == 15 || index == 20){
		left = -1;
	}
	if(index == 4 || index == 9 || index == 14 || index == 19){
		right = -1;
	}

	//新規マスの位置を取得
	let offset = getNewIndex(top);
	if(offset != -1){
		arr.push(offset);
	}
	offset = getNewIndex(left);
	if(offset != -1){
		arr.push(offset);
	}
	offset = getNewIndex(right);
	if(offset != -1){
		arr.push(offset);
	}
	offset = getNewIndex(bottom);
	if(offset != -1){
		arr.push(offset);
	}

//console.log("[" + index + "]****:" + arr);

	//新規マスの隣接マスが固定マス
	for (let i=0; i < arr.length; i++) {
		if(checkFix(arr[i])){
//console.log("2hit [" + index + "]→[" + arr[i] + "]→固定");
			return true;
		}
	}



	let arr2 = new Array();
	//新規×2マスの隣接マスが固定マスかチェック
	for (let i=0; i < arr.length; i++) {
		top    = parseInt(arr[i] - 5, 10);
		left   = parseInt(arr[i] - 1, 10);
		right  = parseInt(arr[i] + 1, 10);
		bottom = parseInt(arr[i] + 5, 10);

		if(arr[i] == 5 || arr[i] == 10 || arr[i] == 15 || arr[i] == 20){
			left = -1;
		}
		if(arr[i] == 4 || arr[i] == 9 || arr[i] == 14 || arr[i] == 19){
			right = -1;
		}

		//新規マスの位置を取得
		offset = getNewIndex(top);
		if(offset != -1){
			arr2.push(offset);
		}
		offset = getNewIndex(left);
		if(offset != -1){
			arr2.push(offset);
		}
		offset = getNewIndex(right);
		if(offset != -1){
			arr2.push(offset);
		}
		offset = getNewIndex(bottom);
		if(offset != -1){
			arr2.push(offset);
		}

		//新規×2マスの隣接マスが固定マス
		for (let j=0; j < arr2.length; j++) {
			if(checkFix(arr2[j])){
//console.log("3hit [" + index + "]→[" + arr[i] + "]→[" + arr2[j] +"]→固定");
				return true;
			}
		}
	}

	let arr3 = new Array();
	//新規×3マスの隣接マスが固定マスかチェック
	for (let i=0; i < arr2.length; i++) {
		top    = parseInt(arr2[i] - 5, 10);
		left   = parseInt(arr2[i] - 1, 10);
		right  = parseInt(arr2[i] + 1, 10);
		bottom = parseInt(arr2[i] + 5, 10);

		if(arr2[i] == 5 || arr2[i] == 10 || arr2[i] == 15 || arr2[i] == 20){
			left = -1;
		}
		if(arr2[i] == 4 || arr2[i] == 9 || arr2[i] == 14 || arr2[i] == 19){
			right = -1;
		}

		//新規マスの位置を取得
		offset = getNewIndex(top);
		if(offset != -1){
			arr3.push(offset);
		}
		offset = getNewIndex(left);
		if(offset != -1){
			arr3.push(offset);
		}
		offset = getNewIndex(right);
		if(offset != -1){
			arr3.push(offset);
		}
		offset = getNewIndex(bottom);
		if(offset != -1){
			arr3.push(offset);
		}

		//新規×3マスの隣接マスが固定マス
		for (let j=0; j < arr3.length; j++) {
			if(checkFix(arr3[j])){
//console.log("4hit [" + index + "]→[" + arr[0] + "]→[" + arr2[i] + "]→[" + arr3[j] +"]→固定");
				return true;
			}
		}
	}

	return false;
}
//--------------------------------------------------
//隣接マスが固定マスかチェック
//--------------------------------------------------
function checkFix(index) {
	let isOk = false;
	let top    = parseInt(index - 5, 10);
	let left   = parseInt(index - 1, 10);
	let right  = parseInt(index + 1, 10);
	let bottom = parseInt(index + 5, 10);

	if(index == 5 || index == 10 || index == 15 || index == 20){
		left = -1;
	}
	if(index == 4 || index == 9 || index == 14 || index == 19){
		right = -1;
	}

	//隣接しているマスが固定マスかチェック
	if(getFixIndex(top)   != -1 || getFixIndex(left)   != -1 ||
	   getFixIndex(right) != -1 || getFixIndex(bottom) != -1 ){
		isOk = true;
	}
	return isOk;
}
//--------------------------------------------------
//固定マスの位置を取得
//--------------------------------------------------
function getFixIndex(index) {
	let offset = -1;
	if(index >= 0 && index <= 24){
		if(nowPerson.allPuts[index]){
			offset = index;
		}
	}
	return offset;
}
//--------------------------------------------------
//新規マスの位置を取得
//--------------------------------------------------
function getNewIndex(index) {
	let offset = -1;
	if(index >= 0 && index <= 24){
		for (let i=0; i < nowPerson.nowPuts.length; i++) {
			if(nowPerson.nowPuts[i] == index){
				offset = index;
				break;
			}
		}
	}
	return offset;
}
//--------------------------------------------------
//現在の配置数を取得
//--------------------------------------------------
function getPutCnt() {
	let cnt = 0;
	for (let i=0; i < nowPerson.nowPuts.length; i++) {
		if(nowPerson.nowPuts[i] != -1){
			cnt++;
		}
	}
	return cnt;
}
//--------------------------------------------------
//現在の配置数に追加
//--------------------------------------------------
function addPutCnt(index) {

	for (let i=0; i < nowPerson.nowPuts.length; i++) {
		if(nowPerson.nowPuts[i] == -1){
			nowPerson.nowPuts[i] = index;
			break;
		}
	}
}
//--------------------------------------------------
//マス配置HTML出力
//--------------------------------------------------
function outHtmlPutBox() {
	//配置可能マスHTML出力
	outHtmlCanPuts();

	//HTML出力
	if(isNowMe()){
		getObj("info_putMe").className = "font110 font_bold manMe " + highlightMe;
		getObj("info_putOther").className = "font110 font_bold manOther";

		getObj("info_boxMe").className = "font110 font_bold manMe " + highlightMe;
		getObj("info_boxOther").className = "font110 font_bold manOther";
	}else{
		getObj("info_putMe").className = "font110 font_bold manMe";
		getObj("info_putOther").className = "font110 font_bold manOther " + highlightOther;

		getObj("info_boxMe").className = "font110 font_bold manMe";
		getObj("info_boxOther").className = "font110 font_bold manOther " + highlightOther;
	}

	if(bombMode){
		getObj("info_put" + getNowMeOtherStr()).innerHTML = "爆弾配置中";

		//ボタン制御
		btnIsDisabled("bombBtn",true);	//無効
		if(nowPerson.bombPut != -1){
			btnIsDisabled("endBtn",false);	//有効
		}else{
			btnIsDisabled("endBtn",true);	//無効
		}
	}else{
		getObj("info_put" + getNowMeOtherStr()).innerHTML = "マス配置 " + getPutCnt() + "/" + MAX_PUTS;

		//ボタン制御
		if(getPutCnt() < 5){
			btnIsDisabled("bombBtn",true);	//無効
		}else{
			btnIsDisabled("bombBtn",false);	//有効
		}
		btnIsDisabled("endBtn",true);	//無効
	}

	//現在ターンが自分じゃない場合
	if(isNowMe() == false){
		btnIsDisabled("bombBtn",true);	//無効
		btnIsDisabled("endBtn",true);	//無効
	}

	getObj("info_put" + getWaitMeOtherStr()).innerHTML = "相手のターン";
}
//--------------------------------------------------
//配置可能マスHTML出力
//--------------------------------------------------
function outHtmlCanPuts() {

	//class削除
	for (let i=0; i < tableElements.length; i++) {
		tableElements[i].classList.remove('bk_canManMe');
	}

	if(isNowMe() && bombMode == false && getPutCnt() < 5){
		//固定マス
		for (let i=0; i < nowPerson.allPuts.length; i++) {
			if(nowPerson.allPuts[i]){
				let top    = parseInt(i - 5, 10);
				let left   = parseInt(i - 1, 10);
				let right  = parseInt(i + 1, 10);
				let bottom = parseInt(i + 5, 10);

				if(i == 5 || i == 10 || i == 15 || i == 20){
					left = -1;
				}
				if(i == 4 || i == 9 || i == 14 || i == 19){
					right = -1;
				}
				outHtmlCanPut(top);
				outHtmlCanPut(left);
				outHtmlCanPut(right);
				outHtmlCanPut(bottom);
			}
		}

		//新規マス
		for (let i=0; i < nowPerson.nowPuts.length; i++) {
			if(nowPerson.nowPuts[i] != -1){
				let offset = nowPerson.nowPuts[i];
				let top    = parseInt(offset - 5, 10);
				let left   = parseInt(offset - 1, 10);
				let right  = parseInt(offset + 1, 10);
				let bottom = parseInt(offset + 5, 10);

				if(offset == 5 || offset == 10 || offset == 15 || offset == 20){
					left = -1;
				}
				if(offset == 4 || offset == 9 || offset == 14 || offset == 19){
					right = -1;
				}
				outHtmlCanPut(top);
				outHtmlCanPut(left);
				outHtmlCanPut(right);
				outHtmlCanPut(bottom);
			}
		}
	}
}
//--------------------------------------------------
//配置可能1マスHTML出力
//--------------------------------------------------
function outHtmlCanPut(index) {
	let isOk = true;
	if(index >= 0 && index <= 24){
		//新規マスじゃない
		for (let i=0; i < nowPerson.nowPuts.length; i++) {
			if(nowPerson.nowPuts[i] == index){
				isOk = false;
				break;
			}
		}
		//固定マスじゃない
		if(isOk == true && nowPerson.allPuts[index] == false){
			//class追加
			tableElements[index].classList.add('bk_canManMe');
		}
	}
}


//***************************************************************************************
//***************************************************************************************


//--------------------------------------------------
//【FromHTML】Startボタン押下処理
//--------------------------------------------------
function clickStart() {
	getObj("disp_start").className = "invisible";
	getObj("disp_main").className = "invisible";
	getObj("disp_serch").className = "topImg4";

	getObj("serch_info").innerHTML = "";
	getObj("serch_info").className = "font110 font_bold outline3";
	getObj("serchBackBtn").className = "btn0 outline3 invisible";

	//【Timer2】相手検索中
	switchTimer(2,"ON");

	//自分の名前
	let nameMe = getObj("txtName").value;
	nameMe = nameMe.trim();
	nameMe = zenSpacePadding(nameMe,8);
	//ローカルストレージに保存
	setStorage("UserName", nameMe);

	//相手の名前
	let nameOther = "人間No." + getRandomNum(9,0) + getRandomNum(9,0) + getRandomNum(9,0);
	ranPutMax = 6;//6,3
	ranPutMin = 2;//2,1
	highlightOther = "outline7down";

	//強い相手の遭遇率
	let pass = 40;
	if(survivalMaxCnt >= 20){
		pass = 2;
	}else if(survivalMaxCnt >= 15){
		pass = 5;
	}else if(survivalMaxCnt >= 10){
		pass = 10;
	}else if(survivalMaxCnt >= 5){
		pass = 20;
	}

	//強い相手の場合
	if(getRandomNum(pass,0) == 0){
		let r = getRandomNum(NAME_TEXT.length,0);
		nameOther = NAME_TEXT[r];

		ranPutMax = 3;//6,3
		ranPutMin = 1;//2,1

		highlightOther = "outline7up";
	}
	nameOther = zenSpacePadding(nameOther,8);

	//先手後手順に格納
	if(getMeTurnNo() == 1){
		userNames.push(nameMe);
		userNames.push(nameOther);
	}else{
		userNames.push(nameOther);
		userNames.push(nameMe);
	}

	//ボタン制御
	btnIsDisabled("bombBtn",true);	//無効
	btnIsDisabled("endBtn",true);	//無効
	getObj("disp_btn1").className = "";
	getObj("disp_btn2").className = "invisible";

	document.body.className = "noSelect";

	//現在ターンHTML出力
	outHtmlNowTurn();

/*
	//起動時1回だけ無音で効果音を鳴らす【スマホTimer対策】
	if(isSoundFirst){
		soundFunc("click1");
		soundFunc("click2");
		soundFunc("click3");
		soundFunc("click4");
		soundFunc("click5");
		soundFunc("click6");
		soundFunc("click7");
		soundFunc("click8");
		soundFunc("click9");
		soundFunc("click10");
		soundFunc("click11");
		soundFunc("click12");
		soundFunc("click13");
	}
*/

	//BGM再生
	changeBgm();
	bgmFunc(bgmNow);
}
//--------------------------------------------------
//現在ターンHTML出力
//--------------------------------------------------
function outHtmlNowTurn() {
	getObj("info_gameCnt").innerHTML = gameCnt + "/5";

	if(getMeTurnNo() == 1){
		getObj("info_manMe").innerHTML    = "先手：" + userNames[0];
		getObj("info_manOther").innerHTML = "後手：" + userNames[1];
	}else{
		getObj("info_manMe").innerHTML    = "後手：" + userNames[1];
		getObj("info_manOther").innerHTML = "先手：" + userNames[0];
	}

	if(isNowMe()){
		getObj("info_manMe").className    = "font110 font_bold manMe " + highlightMe;
		getObj("info_manOther").className = "font110 font_bold manOther";
	}else{
		getObj("info_manMe").className    = "font110 font_bold manMe";
		getObj("info_manOther").className = "font110 font_bold manOther " + highlightOther;
	}

	//マス配置HTML出力
	outHtmlPutBox();
}
//--------------------------------------------------
//【Timer2】相手検索中
//--------------------------------------------------
function runTimer2() {

	if(timer2Cnt >= timer2CntMax && timer2IsEndOk){

		//【Timer2】相手検索中
		switchTimer(2,"OFF");

		//ローカルストレージに保存
		setStorage("gameState", "start");

		//対戦開始
		getObj("disp_main").className = "";
		getObj("disp_serch").className = "invisible";

/*
		//効果音ミュートOFF【スマホTimer対策】
		isSoundFirst = false;
*/

		//【Timer4】カウントダウン
		switchTimer(4,"ON");

		//【Timer6】AI【自動操作】
		switchTimer(6,"ON");

		//ボタン制御
		btnIsDisabled("bombBtn",true);	//無効
		btnIsDisabled("endBtn",true);	//無効

		//ゲーム開始
		isGameEnd = false;

	}else{
		timer2Cnt++;
		if(timer2Cnt > 80){
			timer2IsEndOk = false;
			timer2Cnt--;
			getObj("serch_info").className = "font110 white font_bold outline3";
			getObj("serch_info").innerHTML = "・・・タイムアウト・・・<br>対戦相手が見つかりませんでした";
			getObj("serchBackBtn").className = "btn0 outline3";
		}else{
			let cnt = timer2Cnt % 8;
			if(cnt == 0){
				getObj("serch_info").innerHTML = "　　　対戦相手を検索中　　　<br>しばらくお待ちください";
			}else if(cnt == 2){
				getObj("serch_info").innerHTML = "　　・対戦相手を検索中・　　<br>　";
			}else if(cnt == 4){
				getObj("serch_info").innerHTML = "　・・対戦相手を検索中・・　<br>　";
			}else if(cnt == 6){
				getObj("serch_info").innerHTML = "・・・対戦相手を検索中・・・<br>　";
			}
		}
	}
}
//--------------------------------------------------
//【Timer4】カウントダウン
//--------------------------------------------------
function runTimer4() {

	//ゲーム終了している場合
	if(isGameEnd){
		return;
	}
	//【Timer5】カウントダウンTimeOut【自動操作】が動いている
	if(timer5 != null){
		return;
	}

	if(timer4Cnt1 == -1){
		if(timer4Cnt2 == -1){
			//爆発が終わるまで待つ
			if(timer1 == null && timer4AutoOpe2 == false){
				//【Timer4】カウントダウン用カウンター初期化
				timer4Cnt1 = timer4MAX1;
				timer4Cnt2 = timer4MAX2;
			}
		}else{
			if(timer4AutoOpe1 == false){
				getObj("info_timer1").innerHTML = "カウントダウン：";
				getObj("info_timer2").innerHTML = zeroPadding(timer4Cnt2,2);
				getObj("info_timer2").className = "font120 font_bold yellow outline3";
				timer4Cnt2--;
				if(timer4Cnt2 == -1){
					timer4AutoOpe2 = true;	//自動TurnEnd中フラグ:ON
					getObj("info_timer1").innerHTML = "";
					getObj("info_timer2").innerHTML = "－－ 自動操作中 －－";
					getObj("info_timer2").className = "font_bold white outline3";
				}
			}
		}
	}else{
		getObj("info_timer1").innerHTML = "カウントダウン：";
		getObj("info_timer2").innerHTML = zeroPadding(timer4Cnt1,2);
		getObj("info_timer2").className = "font120 font_bold yellow outline3";
		timer4Cnt1--;
		if(timer4Cnt1 == -1){
			timer4AutoOpe1 = true;	//自動マス配置中フラグ:ON
			getObj("info_timer1").innerHTML = "";
			getObj("info_timer2").innerHTML = "－－ 自動操作中 －－";
			getObj("info_timer2").className = "font_bold white outline3";
		}
	}

	//自動マス配置中フラグ:ONの場合
	if(timer4AutoOpe1 == true){

		//ボタン制御
		btnIsDisabled("bombBtn",true);	//無効

		//【Timer5】カウントダウンTimeOut【自動操作】
		switchTimer(5,"ON");
	}

	//自動TurnEnd中フラグ:ONの場合
	if(timer4AutoOpe2 == true){

		//ボタン制御
		btnIsDisabled("endBtn",true);	//無効

		//【Timer5】カウントダウンTimeOut【自動操作】
		switchTimer(5,"ON");
	}
}
//--------------------------------------------------
//【Timer5】カウントダウンTimeOut【自動操作】
//--------------------------------------------------
function runTimer5() {

	//自動マス配置中フラグ:ONの場合
	if(timer4AutoOpe1 == true){

		//【自動操作用】新規マス1つ配置
		autoOnePut("TIMEOUT");
		if(getPutCnt() < 5){
			return;
		}

		//爆弾配置処理
		putBoming();

		getObj("info_timer1").innerHTML = "カウントダウン：";
		getObj("info_timer2").innerHTML = zeroPadding(timer4MAX2,2);
		getObj("info_timer2").className = "font120 font_bold flat outline3";

		//【Timer5】カウントダウンTimeOut自動操作削除
		switchTimer(5,"OFF");

		timer4AutoOpe1 = false;	//自動マス配置中フラグ:OFF
	}


	//自動TurnEnd中フラグ:ONの場合
	if(timer4AutoOpe2 == true){
		if(timer5Cnt == 2){
			//TurnEnd処理
			turnEnding();

			getObj("info_timer1").innerHTML = "カウントダウン：";
			getObj("info_timer2").innerHTML = zeroPadding(timer4MAX1,2);
			getObj("info_timer2").className = "font120 font_bold flat outline3";

			//【Timer5】カウントダウンTimeOut自動操作削除
			switchTimer(5,"OFF");

			timer4AutoOpe2 = false;	//自動TurnEnd中フラグ:OFF
		}else{
			timer5Cnt++;
		}
	}
}
//--------------------------------------------------
//【Timer6】AI【自動操作】
//--------------------------------------------------
function runTimer6() {

	//ゲーム終了している場合
	if(isGameEnd){
		return;
	}
	//現在ターンがAIじゃない場合
	if(isNowMe()){
		return;
	}
	//【Timer5】カウントダウンTimeOut【自動操作】が動いている
	if(timer5 != null){
		return;
	}


	timer6Cnt++;

	if(timer6AutoOpe1 == false && timer6AutoOpe2 == false && timer6AutoOpe3 == false && timer6Cnt == timer6CntMax){
		timer6Cnt = 0;
		timer6CntMax = getRandomNum(ranPutMax,ranPutMin);

		//自動マス配置中フラグ:ON
		timer6AutoOpe1 = true;
	}

	//自動マス配置中フラグ:ONの場合
	if(timer6AutoOpe1 == true && timer6Cnt == timer6CntMax){
		//【自動操作用】新規マス1つ配置
		autoOnePut("AI");
		if(getPutCnt() < 5){
			timer6Cnt = 0;
			timer6CntMax = getRandomNum(ranPutMax,ranPutMin);
			return;
		}

		//爆弾配置処理
		putBoming();

		timer6Cnt = 0;
		timer6CntMax = getRandomNum(ranPutMax,ranPutMin);

		//自動マス配置中フラグ:OFF
		timer6AutoOpe1 = false;

		//自動爆弾配置中フラグ:ON
		timer6AutoOpe2 = true;

		return;
	}

	//自動爆弾配置中フラグ:ONの場合
	if(timer6AutoOpe2 == true && timer6Cnt == timer6CntMax){
		//【自動操作用】爆弾配置
		autoBombPut();

		timer6Cnt = 0;
		timer6CntMax = getRandomNum(ranPutMax,ranPutMin);

		//自動爆弾配置中フラグ:OFF
		timer6AutoOpe2 = false;

		//自動TurnEnd中フラグ:ON
		timer6AutoOpe3 = true;

		return;
	}

	//自動TurnEnd中フラグ:ONの場合
	if(timer6AutoOpe3 == true && timer6Cnt == timer6CntMax){
		//TurnEnd処理
		turnEnding();

		timer6Cnt = 0;
		timer6CntMax = getRandomNum(6,3);

		//自動TurnEnd中フラグ:OFF
		timer6AutoOpe3 = false;
	}
}
//--------------------------------------------------
//【自動操作用】新規マス1つ配置
//--------------------------------------------------
function autoOnePut(type) {

	let arr = new Array();

	//未配置の新規マスを埋める
	for (let i=0; i < nowPerson.nowPuts.length; i++) {
		if(nowPerson.nowPuts[i] == -1){
			for (let j=0; j < nowPerson.allPuts.length; j++) {
				if(nowPerson.allPuts[j] == false){
					let isSame = false;
					for (let k=0; k < nowPerson.nowPuts.length; k++) {
						if(nowPerson.nowPuts[k] == j){
							isSame = true;
							break;
						}
					}
					//配置できるかチェック
					if(isSame == false && isOnePut(j)){
						//マーキング候補一覧に入れる
						arr.push(j);
					}
				}
			}
		}
	}


	//新規マス配置
	if(arr.length > 0){

		let index = arr[0];//タイムアウトは機械的に先頭のindexを入れる

		//AIの場合
		let arr2 = new Array();
		if(type == "AI"){
			let isFind = false;
			let other = getNowWaitTurn()-1;
			//マーキング候補一覧の中で空マスがあったらそこにする
			for (let i=0; i < arr.length; i++) {
				let no = arr[i];
				if(persons[other].allPuts[no] == false){
					arr2.push(no);
					isFind = true;
				}
			}

			if(isFind){
				//複数の空マスからランダムで選ぶ
				let r = getRandomNum(arr2.length,0);
				index = arr2[r];
			}else{
				//マーキング候補一覧の中で空マスが無い場合はランダム
				let r = getRandomNum(arr.length,0);
				index = arr[r];
			}

			//配置マスが相手のマスだった場合たまにキャンセル動作をする
			if(getRandomNum(10,0) == 0){
				let arr3 = new Array();
				for (let i=0; i < nowPerson.nowPuts.length; i++) {
					let ttt = nowPerson.nowPuts[i];
					if(ttt != -1 && persons[(getNowWaitTurn()-1)].allPuts[ttt]){
						arr3.push(ttt);
					}
				}
				if(arr3.length != 0){
					let r = getRandomNum(arr3.length,0);
					index = arr3[r];
				}
			}
		}

		//マーキング
		putMarking(index);
	}
}
//--------------------------------------------------
//【自動操作用】爆弾配置
//--------------------------------------------------
function autoBombPut() {

	let arr = new Array();

	//爆弾配置可能場所を配列に入れる
	for (let i=0; i < tableElements.length; i++) {
		if(tableElements[i].className == "bk_bomb"){
			arr.push(i);
		}
	}

	//爆弾ランダム配置
	let r = getRandomNum(arr.length,0);
	nowPerson.bombPut = arr[r];
}


//***************************************************************************************
//***************************************************************************************


//--------------------------------------------------
//【FromHTML】爆弾配置ボタン押下処理
//--------------------------------------------------
function clickPutBomb() {

	//現在ターンが自分じゃない場合
	if(isNowMe() == false){
		return;
	}

	//爆弾配置処理
	putBoming();
}
//--------------------------------------------------
//爆弾配置処理
//--------------------------------------------------
function putBoming() {

	//爆弾配置モード:ONの場合
	if(bombMode){
		return;
	}
	//配置数が5マス未満場合
	if(getPutCnt() < 5){
		return;
	}

	//爆弾配置モード:ON
	bombMode = true;

	//マス配置を全配置に設定
	for (let i=0; i < nowPerson.nowPuts.length; i++) {
		let index = nowPerson.nowPuts[i];
		if(index != -1){
			nowPerson.allPuts[index] = true;
		}
	}
	//現在の配置数を初期化
	nowPerson.nowPuts = [-1,-1,-1,-1,-1];

	//マス背景を爆弾配置モード色にする
	for (let i=0; i < nowPerson.allPuts.length; i++) {
		if(nowPerson.allPuts[i]){
			tableElements[i].className = "bk_bomb";
		}
	}

	//爆弾が未配置の場合最初に見つかった自マスに配置
	if(nowPerson.bombPut == -1){
		for (let i=0; i < nowPerson.allPuts.length; i++) {
			if(nowPerson.allPuts[i]){
				//爆弾配置(自分の爆弾のみ)
				nowPerson.bombPut = i;
				if(isNowMe()){
					getObj("td"+i).className = "imgBomb1";
				}
				break;
			}
		}
	}

	//マス配置HTML出力
	outHtmlPutBox();

	//【Timer4】カウントダウン用カウンター初期化
	timer4Cnt1 = -1;
	timer4AutoOpe1 = false;	//自動マス配置中フラグ:OFF
}


//***************************************************************************************
//***************************************************************************************


//--------------------------------------------------
//【FromHTML】TurnEndボタン押下処理
//--------------------------------------------------
function clickTurnEnd() {

	//現在ターンが自分じゃない場合
	if(isNowMe() == false){
		return;
	}

	//TurnEnd処理
	turnEnding();
}
//--------------------------------------------------
//TurnEnd処理
//--------------------------------------------------
function turnEnding() {

	//ボタン制御
	btnIsDisabled("bombBtn",true);	//無効
	btnIsDisabled("endBtn",true);	//無効

	//マス背景を爆弾配置モード色から確定配置色にする
	for (let i=0; i < nowPerson.allPuts.length; i++) {
		if(	nowPerson.allPuts[i]){
			tableElements[i].className = "bk_fixMan" + getNowMeOtherStr();
		}
	}

	//爆弾配置モード:OFF
	bombMode = false;


	//待機中の人の爆弾の場所
	let bom = persons[(getNowWaitTurn()-1)].bombPut;

	//自分の配置マスに待機中の人の爆弾がある場合は爆破実行
	if(nowPerson.allPuts[bom]){
		soundFunc("click" + getRandomNum(2,8));
		soundFunc("click10");	//bomb2
		//爆破
		doBomb(bom);
		//現在待機中の爆弾を消す
		persons[(getNowWaitTurn()-1)].bombPut = -1;
	}else{
		//ターン交代処理
		TurnEndAfter();
	}
}
//--------------------------------------------------
//爆破
//--------------------------------------------------
function doBomb(index) {
	let topL    = parseInt(index - 6, 10);
	let top     = parseInt(index - 5, 10);
	let topR    = parseInt(index - 4, 10);

	let left    = parseInt(index - 1, 10);

	let right   = parseInt(index + 1, 10);

	let bottomL = parseInt(index + 4, 10);
	let bottom  = parseInt(index + 5, 10);
	let bottomR = parseInt(index + 6, 10);

	if(index == 0 || index == 5 || index == 10 || index == 15 || index == 20){
		topL    = -1;
		left    = -1;
		bottomL = -1;
	}
	if(index == 4 || index == 9 || index == 14 || index == 19 || index == 24){
		topR    = -1;
		right   = -1;
		bottomR = -1;
	}

	//全部で9マス爆破
	boxBomb(topL);
	boxBomb(top);
	boxBomb(topR);

	boxBomb(left);
	boxBomb(index);
	boxBomb(right);

	boxBomb(bottomL);
	boxBomb(bottom);
	boxBomb(bottomR);

	//【Timer1】爆破
	switchTimer(1,"ON");
}
//--------------------------------------------------
//１マス爆破
//--------------------------------------------------
function boxBomb(index) {
	if(index >= 0 && index <= 24){
		//爆発画像を表示
		if(isNowMe()){
			getObj("td"+index).className = "imgExpMeOther";
		}else{
			getObj("td"+index).className = "imgExpMe";
		}

		if(nowPerson.allPuts[index]){
			//自分の配置マスを消す
			nowPerson.allPuts[index] = false;
			if(persons[(getNowWaitTurn()-1)].allPuts[index]){
				tableElements[index].className = "bk_bgMan" + getWaitMeOtherStr();
			}else{
				tableElements[index].className = "bk_empty";
			}

			//自分の爆弾を消す
			if(nowPerson.bombPut == index){
				nowPerson.bombPut = -1;
			}
		}
	}
}
//--------------------------------------------------
//【Timer1】爆破を消す
//--------------------------------------------------
function runTimer1() {

	if(timer1Cnt == 10){
		//爆発画像を消す
		for (let i=0; i < tableElements.length; i++) {
			if(getObj("td"+i).className == "imgExpMe" ||
			   getObj("td"+i).className == "imgExpMeOther"){
				getObj("td"+i).className = "";
			}
		}

		//【Timer1】爆破
		switchTimer(1,"OFF");

		//ターン交代処理
		TurnEndAfter();

	}else{
		timer1Cnt++;
	}
}
//--------------------------------------------------
//ターン交代処理
//--------------------------------------------------
function TurnEndAfter() {

	soundFunc("click11");

	//陣取りできたところを現在待機中ターンのマスから消す
	for (let i=0; i < nowPerson.allPuts.length; i++) {
		if(nowPerson.allPuts[i] && persons[(getNowWaitTurn()-1)].allPuts[i]){
			persons[(getNowWaitTurn()-1)].allPuts[i] = false;
		}
	}

	//マス数HTML出力
	outHtmlBoxCnt();

	//ゲーム終了判定
	checkGameEnd();

	//ゲーム終了していない場合
	if(isGameEnd == false){

		//相手ターン用の背景色に変更
		for (let i=0; i < nowPerson.allPuts.length; i++) {
			//現在ターンのマス
			if(persons[(getNowTurn()-1)].allPuts[i]){
				tableElements[i].className = "bk_bgMan" + getNowMeOtherStr();
			}
			//現在待機中ターンのマス
			if(persons[(getNowWaitTurn()-1)].allPuts[i]){
				tableElements[i].className = "bk_fixMan" + getWaitMeOtherStr();
			}
		}

		//ターンの交代
		if(getNowTurn() == 1){
			nowPerson = persons[1];
		}else{
			nowPerson = persons[0];
			gameCnt++;
		}

		//現在ターンHTML出力
		outHtmlNowTurn();

		//【Timer4】カウントダウン用カウンター初期化
		timer4Cnt1 = timer4MAX1;
		timer4Cnt2 = timer4MAX2;
		timer4AutoOpe1 = false;	//自動マス配置中フラグ:OFF
		timer4AutoOpe2 = false;	//自動TurnEnd中フラグ:OFF

		//ボタン制御
		btnIsDisabled("bombBtn",true);	//無効
		btnIsDisabled("endBtn",true);	//無効
	}
}
//--------------------------------------------------
//ゲーム終了判定
//--------------------------------------------------
function checkGameEnd() {

	//マス数を取得
	let arr = arrBoxCnt();
	let cnt1 = arr[0];
	let cnt2 = arr[1];

	//勝敗出力
	if((getNowTurn() == 2 && gameCnt == 5) || (cnt1 == 0 || cnt2 == 0)){

		isGameEnd = true;

		soundFunc("click12");
		soundFunc("click13");

		//マス数カウント＆マスの背景色を明るくする
		let box1 = 0;
		let box2 = 0;
		for (let i=0; i < nowPerson.allPuts.length; i++) {
			//自分
			if(persons[(getMeTurnNo()-1)].allPuts[i]){
				tableElements[i].className = "bk_fixManMe";
				box1++;
			}
			//相手
			if(persons[(getOtherTurnNo()-1)].allPuts[i]){
				tableElements[i].className = "bk_fixManOther";
				box2++;
			}
		}

		let isWin = false;

		//負け
		if(box1 < box2){
			survivalCnt = 0;

			//ハイライト制御
			getObj("info_boxMe").className = "font110 font_bold manMe";
			getObj("info_boxOther").className = "font110 font_bold manOther " + highlightOther;

/*
			//ボタン制御
			btnIsDisabled("nextBtn",true);	//無効
*/
		}
		//勝ち(引き分け)
		else{
			survivalCnt++;

			isWin = true;

			//ハイライト制御
			getObj("info_boxMe").className = "font110 font_bold manMe " + highlightMe;
			if(box1 == box2){
				getObj("info_boxOther").className = "font110 font_bold manOther " + highlightOther;
			}else{
				getObj("info_boxOther").className = "font110 font_bold manOther";
			}

/*
			//ボタン制御
			btnIsDisabled("nextBtn",false);	//有効
*/
		}

		//ローカルストレージに保存
		setStorage("gameState", "end");
		setStorage("survivalCnt", survivalCnt);
		if(survivalCnt > survivalMaxCnt){
			//ローカルストレージに保存
			setStorage("survivalMaxCnt", survivalCnt);
		}

		getObj("info_manMe").className    = "font110 font_bold manMe";
		getObj("info_manOther").className = "font110 font_bold manOther";

		getObj("info_putMe").innerHTML    = "－対戦終了－";
		getObj("info_putMe").className    = "font110 font_bold manMe";
		getObj("info_putOther").innerHTML = "－対戦終了－";
		getObj("info_putOther").className = "font110 font_bold manOther";

		//ボタン制御
		getObj("disp_btn1").className = "invisible";
		getObj("disp_btn2").className = "";
		btnIsDisabled("topBtn",false);	//有効

		//ゲーム終了メッセージ
		gameEndMsg(isWin);
	}
}
//--------------------------------------------------
//ゲーム終了メッセージ
//--------------------------------------------------
function gameEndMsg(isWin) {

	let msg = "";

	//勝ちMsg
	if(isWin){
		//勝ちMsg再設定
		if(goodArr.length == 0){
			for (let i=0; i < GOOD_TEXT.length; i++) {
				goodArr.push(GOOD_TEXT[i]);
			}
		}
		//勝ちMsg決定
		let r = getRandomNum(goodArr.length,0);
		let goodStr = "<br><br><br><span class='font90 white'>" + goodArr[r] + "</span>";
		msg = "<span class='font140'>　</span><br><span class='font140'>　</span><br><br><span class='font130'>あなたは生き残りました</span><br>サバイバル <span class='font140 white'>" + survivalCnt + "</span> 日経過" + goodStr;
		goodArr.splice(r, 1);
	}
	//負けMsg
	else{
		//負けMsg再設定
		if(badArr.length == 0){
			for (let i=0; i < BAD_TEXT.length; i++) {
				badArr.push(BAD_TEXT[i]);
			}
		}
		//負けMsg決定
		let r = getRandomNum(badArr.length,0);
		let endStr = "<br><br><br><br><span class='font90 white'>" + badArr[r] + "</span>";
		msg = "<span class='font140'>　</span><br><span class='font140'>　</span><br><br><span class='font130'>あなたは死にました</span>" + endStr;
		badArr.splice(r, 1);
	}

	let btnStr = "<br><br><input id='resultClsBtn' type='button' value='閉じる' class='btn1s outline3'>";

	getObj("info_title").innerHTML = "";
	getObj("info_msg").innerHTML = msg + btnStr;
	modalWindow();
}


//***************************************************************************************
//***************************************************************************************

/*
//--------------------------------------------------
//【FromHTML】次の対戦ボタン押下処理
//--------------------------------------------------
function clickNext() {

	//Html初期化処理
	initHtml();

	//【FromHTML】Startボタン押下処理
	clickStart();
}
*/

//***************************************************************************************
//***************************************************************************************


//--------------------------------------------------
//【FromHTML】終了ボタン押下処理
//--------------------------------------------------
function clickTop() {

	//Html初期化処理
	initHtml();

	getObj("disp_start").className = "topImg1";
	getObj("disp_serch").className = "invisible";
	getObj("disp_main").className = "invisible";
}


//***************************************************************************************
//***************************************************************************************


//--------------------------------------------------
//【FromHTML】音設定ボタン押下処理
//--------------------------------------------------
function clickSetup1(type) {

	if(type == 1){
		getObj("disp_start").className = "invisible";
		getObj("disp_setup1").className = "";
	}else{
		getObj("disp_start").className = "topImg1";
		getObj("disp_setup1").className = "invisible";
	}
}
//--------------------------------------------------
//【FromHTML】音設定ボタン押下処理
//--------------------------------------------------
function clickSetup2(type) {

	if(type == 1){
		getObj("disp_start").className = "invisible";
		getObj("disp_setup2").className = "";
	}else{
		getObj("disp_start").className = "topImg1";
		getObj("disp_setup2").className = "invisible";
	}
}
//--------------------------------------------------
//【FromHTML】音設定ボタン押下処理
//--------------------------------------------------
function clickSound(type) {

	if(type == 1){
		if(isSound == "ON"){
			isSound = "OFF";
		}else{
			isSound = "ON";
		}
		getObj("sound1Btn").value = isSound;
		//ローカルストレージに保存
		setStorage("isSound", isSound);
	}else{
		if(isBGM == "ON"){
			isBGM = "OFF";
		}else{
			isBGM = "ON";
		}
		bgmFunc(bgmNow);
		getObj("sound2Btn").value = isBGM;
		//ローカルストレージに保存
		setStorage("isBGM", isBGM);
	}
}
